#!/usr/bin/perl
use Config::IniFiles;

$confId = "";

#system "stty -echo";
#print "Password: ";
#chomp($word = <STDIN>);
#print "\n";
#system "stty echo";



$config = Config::IniFiles->new();

print "RRDBELT configure Manager.\n\n";
$confId = iniGlbal();
iniCpu();
iniNetwork();
iniMemory();
iniSwap();
iniProcess();
allDisk();
print "\nCreate ./configs/".$confId.".ini\n\n";
$config->WriteConfig("./configs/".$confId.".ini");
print "\nCreate Complite.\n\n";


sub iniGlbal
{
    local(@aVal);
    local($def);
    local($input);
    local($comment);

    local($tDef) = 'n';
    local(@tVal) = ('y', 'n');

    my($confId);

    $comment = ";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                  ;;
;;                RRDBELT                                           ;;
;;                                                                  ;;
;;  Author  : Jinoos Lee (jinoos(at)jinoos.com)                     ;;
;;                                                                  ;;
;;  Copyright follow GPL license                                    ;;
;;                                                                  ;;
;;  RRDBELT PHP SNMP ̿ ټ  ¸ Ͽ ׷  ;;
;;  ǥϴ RRDTOOL ο Frontend Դϴ.                  ;;
;;                                                                  ;;
;;            http://www.jinoos.com/rrdbelt/                        ;;
;;                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                  ;;
;;  ȣƮ ȯ漳 Դϴ.                                   ;;
;;                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
";
    print "GLOBAL Setting\n";
    $config->AddSection("GLOBAL");
    $config->SetSectionComment("GLOBAL", $comment);
    ### NAME
    $def   = 'default';
    $confId = getStdin("    Input unique Config ID",*def, *aVal);

    while(-e "configs/".$confId.".ini" && getStdin("\n    +*+*+ WARNNING : configs/".$confId.".ini file exists +*+*+\n\n    Do you want overwrite(configs/".$confId.".ini)",*tDef, *tVal) eq 'n')
    {
        $def   = 'default';
        @aVal  = ();
        $confId = getStdin("    Input unique Config ID",*def, *aVal);
    }

    $config->newval("GLOBAL", "NAME",$confId);
    $config->newval("GLOBAL", "TITLE",$confId);
    
    ### Layout
    @aVal  = ('default', 'phpschool');
    $def   = 'default';
    $input = getStdin("    Input HTML style name",*def, *aVal);
    $config->newval("GLOBAL", "TITLE",$input);

    ### IMGTYPE
    @aVal  = ('GIF', 'PNG');
    $def   = 'GIF';
    $input = getStdin("    Input Image format",*def, *aVal);

    $config->newval("GLOBAL", "TITLE",$input);
    
    print "\n";
    return $confId;
}


sub iniCpu
{
    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "cpu";

    @aVal  = ('y', 'n');
    $def   = 'y';

    print "CPU Setting\n";
    $input = getStdin("    Do you want CPU Graph",*def, *aVal);

    $input eq 'n' && return ;


    ### Layout
#    @aVal  = ('default', 'phpschool');
#    $def   = 'default';
#    $input = getStdin("Input HTML style name ",*def, *aVal);
#    $config->newval("GLOBAL", "TITLE",$input);

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","CPU Load Average");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","CPU Load %");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
#    $config->newval($gid, "GRAPHMIN","-500");

    $config->newval($gid, "BASE","1000");

    $config->newval($gid, "DATA1","CMD:GAUGE:U:U:__UTIL__/cpuinfo.sh 1");
    $config->newval($gid, "DATA2","CMD:GAUGE:U:U:__UTIL__/cpuinfo.sh 5");
    $config->newval($gid, "DATA3","CMD:GAUGE:U:U:__UTIL__/cpuinfo.sh 15");

#    $config->newval($gid, "CDATA1","CDATA1:DATA1:DATA2:+");

    $config->newval($gid, "GRAPH1","DATA1:1min AV :AREA:#0000C3:");
    $config->newval($gid, "GRAPH2","DATA2:5min AV :LINE:#FD7F34:");
    $config->newval($gid, "GRAPH3","DATA3:15min AV:LINE:#F0E900:");
    print "\n";
}


sub iniNetwork
{
    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "network_eth0";

    @aVal  = ('y', 'n');
    $def   = 'y';

    print "NETWORK Setting\n";
    $input = getStdin("    Do you want Network(eth0) Graph",*def, *aVal);

    $input eq 'n' && return ;

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","Network eth0 Status");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","In Byte/s  - Out Byte/s");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
#    $config->newval($gid, "GRAPHMIN","-500");

    $config->newval($gid, "BASE","1000");

    $config->newval($gid, "DATA1","CMD:COUNTER:-15000000:15000000:__UTIL__/netinfo.sh eth0 send byte");
    $config->newval($gid, "DATA2","CMD:COUNTER:-15000000:15000000:__UTIL__/netinfo.sh eth0 recv byte");

    $config->newval($gid, "CDATA1","CDATA1:DATA2:-1:*");
    $config->newval($gid, "CDATA2","CDATA2:DATA1:CDATA1:+");

    $config->newval($gid, "GRAPH1","DATA1:Output Byte/s:AREA:#0000C3:");
    $config->newval($gid, "GRAPH2","CDATA1:Input  Byte/s:AREA:#FD7F34:");
    $config->newval($gid, "GRAPH3","CDATA2:Out-In Diff  :LINE:#F0E900:");
    print "\n";
}


sub iniMemory
{
    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "memory";

    @aVal  = ('y', 'n');
    $def   = 'y';

    print "MEMORY Setting\n";

    $input = getStdin("    Do you want Memory Graph",*def, *aVal);

    $input eq 'n' && return ;

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","Memory usage");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","Memory usage");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
    $config->newval($gid, "GRAPHMIN","-1");

    $config->newval($gid, "BASE","1024");

    $config->newval($gid, "DATA1","CMD:GAUGE:U:U:__UTIL__/meminfo.sh total");
    $config->newval($gid, "DATA2","CMD:GAUGE:U:U:__UTIL__/meminfo.sh cache");
    $config->newval($gid, "DATA3","CMD:GAUGE:U:U:__UTIL__/meminfo.sh buffer");
    $config->newval($gid, "DATA4","CMD:GAUGE:U:U:__UTIL__/meminfo.sh free");

    $config->newval($gid, "CDATA1","CDATA1:DATA1:DATA2:-");
    $config->newval($gid, "CDATA2","CDATA2:CDATA1:DATA3:-");
    $config->newval($gid, "CDATA2","CDATA3:CDATA2:DATA4:-");

    $config->newval($gid, "GRAPH1","DATA2:Cached    :AREA:#0000C3:");
    $config->newval($gid, "GRAPH2","DATA3:Buffers   :STACK:#FD7F34:");
    $config->newval($gid, "GRAPH3","CDATA3:Other Used:STACK:#F0E900:");
    $config->newval($gid, "GRAPH3","DATA4:Free      :STACK:#00E100:");
    $config->newval($gid, "GRAPH3","DATA1:Total     :LINE:#000000:");
    print "\n";
}


sub iniSwap
{
    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "swap";

    @aVal  = ('y', 'n');
    $def   = 'y';

    print "SWAP Setting\n";
    $input = getStdin("    Do you want Swap memory Graph",*def, *aVal);

    $input eq 'n' && return ;

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","Swap Disk Usage");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME ",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","Swap Disk Usage (Byte)");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
    $config->newval($gid, "GRAPHMIN","-1");

    $config->newval($gid, "BASE","1024");

    $config->newval($gid, "DATA1","CMD:GAUGE:U:U:__UTIL__/meminfo.sh swaptotal");
    $config->newval($gid, "DATA2","CMD:GAUGE:U:U:__UTIL__/meminfo.sh swapfree");

    $config->newval($gid, "CDATA1","CDATA1:DATA1:DATA2:-");

    $config->newval($gid, "GRAPH1","CDATA1:Used Space:AREA:#0000C6:");
    $config->newval($gid, "GRAPH2","DATA2:Free Space:STACK:#F7EB00:");
    $config->newval($gid, "GRAPH3","DATA1:Total     :LINE:#FF7D31:");
    print "\n";
}



sub iniProcess
{
    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "process";

    @aVal  = ('y', 'n');
    $def   = 'y';

    print "PROCESS Setting\n";
    $input = getStdin("    Do you want Process Counter Graph",*def, *aVal);

    $input eq 'n' && return ;

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","Swap Disk Usage");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","Process counter");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
    $config->newval($gid, "GRAPHMIN","-1");

    $config->newval($gid, "BASE","1024");

    $config->newval($gid, "DATA1","CMD:GAUGE:U:U:__UTIL__/processcnt.sh httpd");
    $config->newval($gid, "DATA2","CMD:GAUGE:U:U:__UTIL__/processcnt.sh mysqld");
    $config->newval($gid, "DATA3","CMD:GAUGE:U:U:__UTIL__/processcnt.sh sendmail");
    $config->newval($gid, "DATA4","CMD:GAUGE:U:U:__UTIL__/processcnt.sh proftpd");
    $config->newval($gid, "DATA5","CMD:GAUGE:U:U:__UTIL__/processcnt.sh sshd");
    $config->newval($gid, "DATA6","CMD:GAUGE:U:U:__UTIL__/processcnt.sh /bin/sh");
    $config->newval($gid, "DATA7","CMD:GAUGE:U:U:ps -xa | wc -l");

#    $config->newval($gid, "CDATA1","CDATA1:DATA1:DATA2:-");

    $config->newval($gid, "GRAPH1","DATA1:Httpd     :AREA:#0000C3:");
    $config->newval($gid, "GRAPH2","DATA2:Mysqld    :STACK:#FF00FF:");
    $config->newval($gid, "GRAPH3","DATA3:Sendmail  :STACK:#FF2C31:");
    $config->newval($gid, "GRAPH4","DATA4:ProFTP    :STACK:#FD7F34:");
    $config->newval($gid, "GRAPH5","DATA5:SSH       :STACK:#F0E900:");
    $config->newval($gid, "GRAPH6","DATA6:shell     :STACK:#00E100:");
    $config->newval($gid, "GRAPH7","DATA7:Total     :LINE:#000000:");
    print "\n";
}



sub allDisk
{

    local(@aVal);
    local($def);
    local($input);

    print "DISK Setting\n";
    @aVal  = ('y', 'n');
    $def   = 'y';
    $input = getStdin("    Do you want Disk Usage Graph",*def, *aVal);
    $input eq 'n' && return ;

    my(@devList)  = grep(/^\/dev/,`df`);
    my($each);
    my(@seach);

    foreach $each (@devList)
    {
        @seach = split(/[ \n\t]+/, $each);
        iniDisk(substr($seach[0], 5), $seach[5]);
    }
    print "\n";
}

sub iniDisk
{
    my($device)     = $_[0];
    my($mountPoint) = $_[1];

    local(@aVal);
    local($def);
    local($input);
    local($gid)      = "disk_".$device;

    print "\n    MountPoint : $mountPoint\n";
    @aVal  = ('y', 'n');
    $def   = 'y';

    $input = getStdin("    Do you want '$mountPoint' Graph",*def, *aVal);

    $input eq 'n' && return ;

    $config->AddSection($gid);
    $config->newval($gid, "TITLE","Disk Usage $mountPoint");
    $config->newval($gid, "GRAPHON","1");

    @aVal  = ('WHITE', 'BLACK', 'KHAKI', 'PHPSCHOOL');
    $def   = 'WHITE';
    $input = getStdin("    Select graph THEME",*def, *aVal);
    $config->newval($gid, "GRAPHTHEME",$input);

    $config->newval($gid, "YLABLE","Disk Usage");
    $config->newval($gid, "HIDSGRID","0");

    $config->newval($gid, "WIDTH","400");
    $config->newval($gid, "HEIGHT","100");

#    $config->newval($gid, "GRAPHMAX","500");
    $config->newval($gid, "GRAPHMIN","-1");

    $config->newval($gid, "BASE","1024");

    $config->newval($gid, "DATA1","CMD:GAUGE:U:U:__UTIL__/diskinfo.sh $device total");
    $config->newval($gid, "DATA2","CMD:GAUGE:U:U:__UTIL__/diskinfo.sh $device used");

    $config->newval($gid, "CDATA1","CDATA1:DATA1:DATA2:-");

    $config->newval($gid, "GRAPH1","DATA2:Used Space:AREA:#0000C6:");
    $config->newval($gid, "GRAPH2","CDATA1:Free Space:STACK:#F7EB00:");
    $config->newval($gid, "GRAPH3","DATA1:Total     :LINE:#FF7D31:");
}



sub getStdin
{
    my($msg) = $_[0];
    *def     = $_[1];
    *aVal    = $_[2];


    while(1)
    {
        print $msg;
        length($def) && print " (DEFAULT:".$def.")";
        ($#aVal+1)   && print " [".join('|', @aVal)."]";
        print " ? ";
        chomp($input = <STDIN>);
        $input =~ s/^[ ]+//g;
        $input =~ s/[\n]+//g;
        checkValid(*input, *def, *aVal) && return $input;
    }
}


sub checkValid
{
    *input     = $_[0];
    *def       = $_[1];
    *aVal      = $_[2];

    if(length($input))
    {
        $#aval eq -1 && return $input;

        foreach $var (@aVal)
        {
            $var eq $input && return 1;
        }
        print "Error : Plz Select one value in Options.\n";
        return 0;
    }

    if(length($def)!=0)
    {
        $input = $def;
        return 1;
    }else
    {
        print "Error : Plz input value.\n";
        return 0;
    }
}